#coding:utf8
# API 端点
import json
import requests

url = "http://120.132.118.205:21000/api/generate"

models = {
    "qwq:32b": "qwq:32b",
    "deepseek-r1:7b": "deepseek-r1:7b",
    "deepseek-r1:1.5b": "deepseek-r1:1.5b",
  }

def request_llm(prompt, model="deepseek-r1:1.5b"):
    # 请求数据
    data = {
        "model": model,
        "prompt": prompt,
        "stream": False,
        'temperature': 0.6,
        'top_p': 0.95,
        'min_p': 0,
        "options": {
            "num_ctx": 4096
        }
    }

    # 发送 POST 请求
    response = requests.post(url, json=data)

    # 检查响应状态码
    if response.status_code == 200:
        result = response.json()
        return_text = result["response"]
        return_text = json.dumps(return_text, ensure_ascii=False)
        return_text = json.loads(return_text)
        token_count = result["eval_count"]
        cost_time = result["eval_duration"]
        cost_time = round(cost_time / 1e9, 2)
        speed = token_count / cost_time
        print(f'回答tokens数{token_count}, 耗时{cost_time} s, 速度{speed} tokens/s')
    else:
        print(f"请求失败，状态码: {response.status_code}，错误信息: {response.text}")
        return_text = response.text
    return response.status_code, return_text


if __name__ == '__main__':

    a = '''
#公告内容开始:
-------------------------------
%s
-------------------------------
#公告内容结束
##任务开始
#角色
招投标信息提取专家
#工作流程
1. 通读全文
2. 找到其中的招标人
3. 找到其中的中标信息，如中标人所在标段的中标金额
#规范
1. 要求提取的招标人和中标人必须是机构实体，如不是，则为""
2. 招标人是招标公告的业主单位
3. 中标人必须是该标的中标企业
4. 标段号是指中标人所中标的包号：如A包则为A，1包则为1
5. 中标信息中的中标人名称、中标金额和标段号必须和文中的信息对应，如果有多个，则再数组中返回多个
6. 中标人只需要提取能明确是第一中标人的,如未明确第一中标人的情况下，不应随意提取
7. 招标人联系方式只提取属于招标人的联系方式，联系电话只需要固话和手机
8. 项目预算和中标金额返回金额+单位的格式
#返回结果
结果返回json格式{"招标信息":{"招标人名称":"","项目预算":"","招标人联系方式":[{"联系人":"","联系电话":""}]},"中标信息":[{"中标人名称":"","中标金额":"":"标段号":""}]}
    '''
    code, answer = request_llm(a)
    print(answer)